kuangbin专题一 简单搜索 F - Prime Path

F - Prime Path


The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033 
1733 
3733 
3739 
3779 
8779 
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

#include<iostream>
#include<cstring>
#include<algorithm>
#include<queue>
using namespace std;
int t[10005],c[10005],d[10],N,n,som,m;
int sum;
struct w{
	int x;
	int sum;
};
void bfs()
{
	queue<w>a;
	w temp;
	temp.x=n;
	temp.sum=0;
	a.push(temp);
	while(!a.empty()){
		w b;
		b=a.front(); 
		a.pop();
		int x1=b.x;
		int sum1=b.sum;
		if(x1==m){
			cout<<sum1<<endl;
			return;
		} 
		for(int i=1;i<10;i++){
			w e;
			int xi=e.x=x1/10*10+i;
			int sumi=e.sum=sum1+1;
			if(xi!=x1&&c[xi]==0&&!t[xi]){
				c[xi]=1;
				a.push(e);
			} 
		}
		for(int i=0;i<10;i++){
			w e;
			int xi=e.x=x1/100*100+i*10+x1%10;
			int sumi=e.sum=sum1+1;
			if(c[xi]==0&&!t[xi]&&xi!=x1){
				c[xi]=1;
				a.push(e);
			} 
		}
		for(int i=0;i<10;i++){
			w e;
			int xi=e.x=x1/1000*1000+i*100+x1%100;
			int sumi=e.sum=sum1+1;
			if(c[xi]==0&&!t[xi]&&xi!=x1){
				c[xi]=1;
				a.push(e);
			} 
		}
		for(int i=1;i<10;i++){
			w e;
			int xi=e.x=x1%1000+1000*i;
			int sumi=e.sum=sum1+1;
			if(c[xi]==0&&!t[xi]&&xi!=x1){
				c[xi]=1;
				a.push(e);
			} 
		}
	}
	
}
int main() 
{

	memset(t,0,sizeof(t));
	for(int i=999;i<=10004;i++)
	{
		for(int j=2;j<i;j++)
		{
			if(i%j==0)
			{
				t[i]=1;!!!!!!!
				break;		
			}

		}
    }
	cin>>N; 
	while(N--)
	{
		som=0;
		memset(c,0,sizeof(c));
		memset(d,0,sizeof(d));
		cin>>n>>m;
		bfs();
	 } 
	 
  return 0;
}

哇 多捞啊 找错误找了1个多小时,各种改程序,一直纳闷为什么不管输入哪两个素数次数都是4!!就是程序中感叹号哪里,没错你没有看错!!!多捞啊,中间有一次还怀疑是不是表没打出来,然后显示了一遍素数表,竟然没发现!!!!!一道大水题浪费了两个小时!!!!以后千万要细心!!!
说一下思路 bfs每次只能一位变化变化后也还是素数,求变化的最小次数。 心情很烦燥,本来今天可以做最少两道的。多捞啊!!!
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值